Bug 873292 - libvirt: terminating vm on signal 15 when hibernate fails on ENOSPACE
Summary: libvirt: terminating vm on signal 15 when hibernate fails on ENOSPACE
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: libvirt
Version: 6.3
Hardware: x86_64
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Michal Privoznik
QA Contact: Virtualization Bugs
URL:
Whiteboard:
Keywords: ZStream
Depends On: 866369
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-11-05 13:58 UTC by Chris Pelland
Modified: 2012-11-22 09:40 UTC (History)
13 users (show)

(edit)
Cause:
When saving a domain onto disk, libvirt injects this iohelper process in between to be able to do aligned writes (these are important when by-passing kernel caches). This process basically reads data from qemu into internal buffer and write it into passed file.

Consequence: 
With right combination of filesystem where the destination file resides and bad timing it was possible that data was not written and kernel did not report out of space error (ENOSPC). For instance, NFS polls for the free space on NFS server, so data lives in kernel cache and writing application has no clue about the error. The error is reported when kernel decides to send data to NFS server, however the iohelper process may have already exited meanwhile.

Fix:
The proper fix is to issue fdatasync() which enforce data to be actually written onto disk. This will catch any write error (even ENOSPC).

Result:
If there is any write error, it can be caught and reported not ignored as before.
Clone Of:
(edit)
Last Closed: 2012-11-22 09:40:19 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2012:1484 normal SHIPPED_LIVE libvirt bug fix update 2012-11-22 14:39:12 UTC

Description Chris Pelland 2012-11-05 13:58:15 UTC
This bug has been copied from bug #866369 and has been proposed
to be backported to 6.3 z-stream (EUS).

Comment 8 Huang Wenlong 2012-11-15 07:51:15 UTC
Hi, Yaniv Kaul 

This bug our qe can not reprodue it ,could you help me to verify this bug and  by  Friday EST ? 
Thanks very much



Wenlong

Comment 9 Haim 2012-11-15 07:58:40 UTC
(In reply to comment #8)
> Hi, Yaniv Kaul 
> 
> This bug our qe can not reprodue it ,could you help me to verify this bug
> and  by  Friday EST ? 
> Thanks very much
> 
> 
> 
> Wenlong

Hi, Dafna will verify this bug.

Comment 12 Dafna Ron 2012-11-15 16:09:51 UTC
verified on libvirt-0.9.10-21.el6_3.6

Comment 14 errata-xmlrpc 2012-11-22 09:40:19 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2012-1484.html


Note You need to log in before you can comment on or make changes to this bug.